package com.winhc.kafka;

import com.winhc.repository.CompanyRepository;
import com.winhc.repository.PersonRepository;
import lombok.extern.slf4j.Slf4j;
import org.apache.kafka.clients.consumer.Consumer;
import org.apache.kafka.clients.consumer.ConsumerRecord;
import org.neo4j.driver.*;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.context.annotation.Bean;
import org.springframework.kafka.annotation.KafkaListener;
import org.springframework.kafka.annotation.TopicPartition;
import org.springframework.kafka.listener.ConsumerAwareListenerErrorHandler;
import org.springframework.kafka.listener.ListenerExecutionFailedException;
import org.springframework.kafka.support.Acknowledgment;
import org.springframework.messaging.Message;
import org.springframework.messaging.handler.annotation.Payload;
import org.springframework.stereotype.Service;

import java.util.*;
import java.util.stream.Collectors;

/**
 * @author π
 * @Description:
 * @date 2020/12/24 10:03
 */
@Slf4j
//@Service
public class KafkaConsumer {

    @Autowired
    CompanyRepository companyRepository;
    @Autowired
    PersonRepository personRepository;
    @Autowired
    Driver driver;



    @KafkaListener(id = "id1",
            topicPartitions = {@TopicPartition(topic = "test",
                    partitions = { "0" })
                    //partitionOffsets = @PartitionOffset(partition = "0", initialOffset = "0"))
                    },
            groupId = "${spring.kafka.consumer.group-id}", containerFactory = "containerFactory", errorHandler = "consumerAwareListenerErrorHandler1")
    public void consumerRelation(List<ConsumerRecord<?, ?>> records, Acknowledgment ack) {
        long start = System.currentTimeMillis();
        List<Map<String, Object>> batch_list = records.stream().filter(r -> {
            return (r != null && r.value() != null);
        }).map(r -> {
            String s = r.value().toString();
//            int disableDecimalFeature = JSON.DEFAULT_PARSER_FEATURE & ~Feature.UseBigDecimal.getMask();
//            SerializeConfig config = SerializeConfig.getGlobalInstance();
//            config.put(Double.class, new DoubleSerializer("#.#####"));
//            JSONObject JB = JSON.parseObject(s, JSONObject.class, disableDecimalFeature);
            int i = 1/0;
            Map<String, Object> map = new HashMap<>();
            return map;
        }).collect(Collectors.toList());
        System.out.println("list query: " + batch_list.size());

//        Session session = driver.session();
//        final String cql = "WITH  {batch_list} AS batch_list \n" +
//                "UNWIND batch_list AS row \n" +
//                "MERGE(company:COMPANY2{companyId:row.companyId}) \n" +
//                "SET company.name=row.companyName, company.companyId=row.companyId \n" +
//                //"FOREACH (_ IN case when row.personId is not null then [1] else [] end|\n" +
//                "MERGE(person:PERSON2{personId:row.personId}) \n" +
//                "SET person.name=row.personName, person.personId=row.personId \n" +
//                //")" +
//                "WITH person,company,row \n" +
//                "MERGE(person)-[r:高管]->(company) \n" +
//                "SET r.percent=row.percent, r.status=row.status, r.relType=row.relType \n"
////                "WITH person,company,row\n" +
////                "CALL apoc.merge.relationship(person, row.relType, {},{percent:row.percent,status:row.status}, company) YIELD rel \n" +
////                "WITH rel,row \n" +
////                "SET rel.status= row.status, rel.percent= row.percent \n"
//                ;
//        Map parameters = new HashMap() {{
//            put("batch_list", batch_list);
//        }};
//
//        String data = session.writeTransaction(new TransactionWork<String>() {
//            @Override
//            public String execute(Transaction tx) {
//                Result result = tx.run(cql, parameters);
//                return "11";
//            }
//        });
        //session.close();
        System.out.println(" 导入 " + batch_list.size() + " company 边");

//        System.out.println("cost: " + (System.currentTimeMillis() - start));

        //提交偏移量
        ack.acknowledge();
    }

    /**
     * 因为手动确认消费，若消费失败，记录重刷
     */
    @Bean("consumerAwareListenerErrorHandler1")
    public ConsumerAwareListenerErrorHandler dealError() {

//        new ConsumerAwareListenerErrorHandler() {
//            @Override
//            public Object handleError(Message<?> message, ListenerExecutionFailedException e, Consumer<?, ?> consumer) {
//                List<ConsumerRecord> c = (List<ConsumerRecord>) message.getPayload();
//                return null;
//            }
//        };
       // return null;
        //return new ConsumerAwareListenerErrorHandler() {
        return (message, e, consumer) -> {
            System.out.println("consumer error:" + e);
            //System.out.println("consumer 1:" + consumer.toString());
            System.out.println("consumer 2:" + message.toString());
            List<ConsumerRecord> records = (List<ConsumerRecord>) message.getPayload();

            List<String> batch_list = records.stream().filter(r -> {
                return (r != null && r.value() != null);
            }).map(r -> {
                String s = r.value().toString();

                return s;
            }).collect(Collectors.toList());
            System.out.println(batch_list);
//            Consumer<?, ?> consumer1 = consumer;
            // TODO 将失败的记录保存到数据库，再用定时任务查询记录，并重刷数据
            return null;
        };
    }
}
