package com.winhc.repository;

import com.winhc.entity.Company;
import org.springframework.data.neo4j.annotation.Query;
import org.springframework.data.neo4j.repository.Neo4jRepository;
import org.springframework.data.repository.query.Param;
import org.springframework.stereotype.Repository;

import java.util.List;


@Repository
public interface CompanyRelationRepository extends Neo4jRepository<Company,String>{

	/**
	 * 返回关系长度为2以内的节点和关系（100条）
	 * @param name
	 * @return
	 */
	@Query("MATCH p=(n:Party)<-[r:SUE*0..2]->(m:Party) where n.name={name} RETURN p order by p desc LIMIT {limitNumber}")
    List<Company> findPartyRelationByName(@Param("name") String name, @Param("limitNumber") int limitNumber);


	@Query("MATCH (a:COMPANY),(b:COMPANY) where a.companyId={aCompanyId} and b.companyId={bCompanyId} MERGE (a)-[r:label {status:{status}}]->(b) return r")
	List<Company> createHolderCompany(@Param("aCompanyId") String aCompanyId,@Param("bCompanyId") String bCompanyId,@Param("status") String status,@Param("label") String label);

//	@Query("MATCH (a:Party),(b:Party)  where a.partyId={aPartyId} and b.partyId={bPartyId} MERGE (a)-[r:SUE{lawsuitId:{lawsuitId},province:{province},city:{city},judge_year:{judge_year},judge_result:{judge_result}}]->(b) return r")
//	List<Company> createSues(@Param("aPartyId") Long aPartyId,@Param("bPartyId") Long bPartyId,@Param("lawsuitId") String lawsuitId,@Param("province") String province,@Param("city") String city,@Param("judge_year") Integer judge_year,@Param("judge_result") String judge_result);

}
