package com.winhc.service;

import com.google.common.collect.Lists;
import com.google.common.collect.Maps;
import com.winhc.dto.CompanyQueryCondition;
import com.winhc.entity.Company;
import lombok.extern.slf4j.Slf4j;
import org.neo4j.driver.*;
import org.neo4j.ogm.session.Session;
import org.neo4j.ogm.session.SessionFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.data.neo4j.transaction.SessionFactoryUtils;
import org.springframework.stereotype.Service;

import java.lang.reflect.Field;
import java.util.List;

@Slf4j
@Service
public class CompanyRelationService {
    @Autowired
    private SessionFactory sessionFactory;
    @Autowired
    Driver driver;

    public List<Company> createCompanyRelation(CompanyQueryCondition c) {
        Session session = SessionFactoryUtils.getSession(sessionFactory);
        StringBuffer cql = new StringBuffer();
        cql.append("MATCH (a:COMPANY),(b:COMPANY) where a.companyId=" + c.getStartId() + " and b.companyId=" + c.getEndId() + " MERGE (a)-[r:" + c.getLabel() + " {status:" + c.getStatus() + "]->(b) return r");

        //拼接基本语句
        //cql.append("MATCH p=(n:Party)<-[r:SUE*0..2{caseStage:'一审',judgeResult:'胜'}]->(m:Party) where n.name='珠海格力电器股份有限公司' RETURN p  LIMIT 100");

        //数据查询结果
        Iterable<Company> experimentNodes = session.query(Company.class, cql.toString(), Maps.newHashMap());

        //返回
        return Lists.newArrayList(experimentNodes);
    }

    public List<Company> createCompanyRelation2(CompanyQueryCondition c) {
        org.neo4j.driver.Session session = driver.session();
        StringBuffer cql = new StringBuffer();
        String a1 = "";
        String a2 = "";
        if (c.getFlag() != null && c.getFlag().equals("1")) {//company
            a1 = "COMPANY";
            a2 = "companyId";
        } else {
            a1 = "PERSON";
            a2 = "personId";
        }
        cql.append("MATCH (a:" + a1 + "),(b:COMPANY) where a." + a2 + "='" + c.getStartId() + "' and b.companyId='" + c.getEndId() + "' MERGE (a)-[r:" + c.getLabel() + " {status:'" + c.getStatus() + "'}]->(b) return r");

        System.out.println(cql.toString());
        List<Record> greeting = session.writeTransaction(new TransactionWork<List<Record>>() {
            @Override
            public List<Record> execute(Transaction tx) {
                Result result = tx.run(String.valueOf(cql));
                //return result.single().get(0).asString();
                return result.list();
            }
        });
        System.out.println(greeting);
        //返回
        return null;
    }

//    public void createCompanyRelation3(CompanyQueryCondition c) {
//
//    }

    public static void main(String[] args) {
//        SueObj sueObj  = new SueObj();
//        sueObj.setJudgeYear("2018");
//        sueObj.setJudgeResult("胜");
//        SerializerFeature.config(0,SerializerFeature.QuoteFieldNames,false);
//       String kk = JSON.toJSONString(sueObj,SerializerFeature.QuoteFieldNames);
//       System.out.println(kk);
    }

    //判断该对象是否: 返回ture表示所有属性为null  返回false表示不是所有属性都是null
    public static boolean isAllFieldNull(Object obj) {
        try {
            Class stuCla = (Class) obj.getClass();// 得到类对象
            Field[] fs = stuCla.getDeclaredFields();//得到属性集合
            boolean flag = true;
            for (Field f : fs) {//遍历属性
                f.setAccessible(true); // 设置属性是可以访问的(私有的也可以)
                Object val = f.get(obj);// 得到此属性的值
                if (val != null) {//只要有1个属性不为空,那么就不是所有的属性值都为空
                    flag = false;
                    break;
                }
            }
            return flag;
        } catch (IllegalAccessException e) {
            log.error("属性判断出错", e);
            return false;
        }

    }
}
